
WELD_RADIUS = 0.25
grabbing = false
gmod = false
HIDE_TEXT = false

function init()

    WELD_RADIUS = GetInt("savegame.mod.weld_radius")
    if WELD_RADIUS == 0 then
        WELD_RADIUS = 0.25
    end
    grabbing = GetBool("savegame.mod.grabbing")
    gmod = GetBool("savegame.mod.gmod")
    HIDE_TEXT = GetBool("savegame.mod.hide_text")

    

    RegisterTool("welder", "Welding Tool", "MOD/tool.vox", 2)
    SetBool("game.tool.welder.enabled", true)    
    loop = LoadLoop("tools/blowtorch-hit-loop.ogg", 1)
end

function contains(table, val)
    for i=1,#table do
        if table[i] == val then 
            return true
        end
    end
    return false
end

function round(number)
    return math.floor(number+0.5)
end

last_placed = 0
drawText = ""
drawText_b = 0
e = nil
grabbing = false
new_equip = false
gmod = false
gmod_o = nil

freeze_anim_body = nil
freeze_anim_time = 0

frozen_shapes = {}

function draw()

    if menuOpen then  -- Settings menu
		UiMakeInteractive()
		menu()

		UiPush()
			UiColor(1, 1, 1)
			UiTranslate(UiCenter(), UiHeight() - 125)
			UiFont("bold.ttf", 80)
			if UiTextButton("Return", 20, 20) then
				menuOpen = false
			end
		UiPop()
	end -- End of Settings Menu


    if freeze_anim_time > 0 then -- Flash when freezing object
        freeze_anim_time = freeze_anim_time*0.95 - 0.01
        DrawBodyHighlight(freeze_anim_body, freeze_anim_time)
    end

    if drawText_b > 0 and not HIDE_TEXT then -- Drawing text
        UiPush()
            UiTranslate(UiCenter(), 60)
            UiFont("bold.ttf", 32)
            UiTextShadow(0,0,0,0.5,1)
            UiColor(1,1,1)
            UiAlign("center")
            UiText(drawText)
        UiPop()
        drawText_b = drawText_b - 1
    end

    if GetString("game.player.tool") == "welder" and not menuOpen then -- Notification that a setting has been changed
        if InputPressed("c") then
            drawText_b = 60
            if grabbing == true then
                grabbing = false
                drawText = "Grab to remove welds : OFF"
            else
                drawText = "Grab to remove welds : ON"
                grabbing = true
            end
            SetBool("savegame.mod.grabbing", grabbing)
        end

        if InputPressed("x") then
            drawText_b = 60
            if gmod == true then
                gmod = false
                drawText = "Teleport welding : OFF"
                gmod_o = nil
            else
                drawText = "Teleport welding : ON"
                gmod = true
            end
            SetBool("savegame.mod.gmod", gmod)
        end

        
    end
end

function tick(dt) -- More influenced by lag, may lead to things happening more than once

    --DebugWatch("Grabbing", grabbing)
    --DebugWatch("gmod", gmod)
    --DebugWatch("hide", HIDE_TEXT)
    --DebugWatch("radius", WELD_RADIUS)

    --if InputDown("g") then
    --    SetInt("savegame.mod.weld_radius", nil)
    --    WELD_RADIUS = 0
    --end

    if PauseMenuButton("Welder settings") then -- If the menu button is pressed
		menuOpen = true
	end

    for n=1, #frozen_shapes do -- Give slight shine to all frozen shapes
        SetBodyActive(frozen_shapes[n], false)
        DrawBodyHighlight(frozen_shapes[n], 0.1)
    end

    if gmod_o ~= nil then -- Draw outlines of currently chosen shape for gmod mode
        DrawBodyOutline(gmod_o, 0, 0.2, 1, 1)
    end

    if GetString("game.player.tool") == "welder" and not menuOpen and GetPlayerVehicle() == 0 then

        if new_equip then -- Information message about current settings
            new_equip = false
            drawText_b = 60
            if grabbing == true then
                drawText = "Grab to remove welds (C) : ON"
            else
                drawText = "Grab to remove welds (C) : OFF"
            end
            if gmod == true then
                drawText = drawText.."\nTeleport welding (X) : ON"
            else
                drawText = drawText.."\nTeleport welding (X) : OFF"
            end
            
        end

         -- Setting Tool Posision

        local offset = Transform(Vec(0.5, -1.1, -0.8))
        SetToolTransform(offset)

        if InputDown("rmb") and grabbing then -- Removing welds from the object
        
            local t = GetPlayerCameraTransform()
            local fwd = TransformToParentVec(t, Vec(0, 0, -1))
            local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, 3)

            if hit then
                j = GetShapeJoints(shape)

                for i=1, #j do
                    local joint = j[i]
                    local t = GetJointType(joint)
                    if t == "ball" or t == "hinge" then
                        DetachJointFromShape(joint, shape)
                    end
                end
            end
        end

        if InputPressed("mmb") then -- Freezing / unfreezing an object
            local t = GetPlayerCameraTransform()
            local fwd = TransformToParentVec(t, Vec(0, 0, -1))
            local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, 3)

            if hit then
                b = GetShapeBody(shape)
                if GetBodyMass(b) > 0 then -- if its not the static world
                    if contains(frozen_shapes, b) then -- should unfreeze the body
                        for n=1, #frozen_shapes do -- remove from the list
                            if frozen_shapes[n] == b then
                                table.remove(frozen_shapes, n)
                            end
                        end
                        SetBodyActive(b, true) -- unfreeze
                    else -- should be frozen
                        table.insert(frozen_shapes, b) -- add to the list of frozen shapes
                    end
                    freeze_anim_body = b
                    freeze_anim_time = 0.5
                end
            end

        end

        if gmod then -- GMOD MODE (Teleport welding on)
            if InputPressed("usetool") then 

                local t = GetPlayerCameraTransform()
                local fwd = TransformToParentVec(t, Vec(0, 0, -1))
                local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, 6)
                local e = VecAdd(t.pos, VecScale(fwd, dist))

                if hit then

                    if gmod_o == nil then -- Set this as the first object
                        if GetBodyMass(GetShapeBody(shape)) ~= 0 then
                            gmod_o = GetShapeBody(shape)
                        end
                    elseif gmod_o == GetShapeBody(shape) then -- reset the first shape
                        gmod_o = nil
                    else
                        gmod_n = GetShapeBody(shape)

                        hit, point, normal, closest_shape = GetBodyClosestPoint(gmod_o, e)

                        n = VecScale(VecSub(point, e), -1)

                        t = GetBodyTransform(gmod_o)
                        t.pos = VecAdd(t.pos, n)
                        SetBodyTransform(gmod_o, t)

                        xml = '<joint id_="201797664" name="balls" pos="'..table.concat(e," ")..'" rot="90 90 90" size="0.25" rotstrength="999" rotspring="0.2" collide="true" limits="15"/>'
                        Spawn(xml,Transform(),false,true)

                        gmod_o = nil
                    end
                end
            end
        else -- NORMAL MODE (Teleport welding off)

            if InputDown("usetool") and not InputDown("rmb") then
            
                local t = GetPlayerCameraTransform()
                local fwd = TransformToParentVec(t, Vec(0, 0, -1))
                local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, 3)
                local e = VecAdd(t.pos, VecScale(fwd, dist))

                if hit then
                    
                    PlayLoop(loop, GetPlayerPos(), 1)
                    
                    ParticleReset()
                    ParticleColor(1, 0.6, 0.4, 1, 0.3, 0.2)
                    ParticleAlpha(1, 0)
                    ParticleRadius(0.01)
                    ParticleGravity(math.random(-10, -1))
                    ParticleDrag(0)
                    ParticleEmissive(math.random(2, 5), 0, "easeout")
                    ParticleTile(3)
                    for i=1,20 do
                        local v = Vec(math.random(-5,5),math.random(-5,5),math.random(-5,5))
                        SpawnParticle(e, v, 10)
                    end

                    if last_placed < 0 then
                        last_placed = 0.5
                        xml = '<joint id_="201797664" name="balls" pos="'..table.concat(e," ")..'" rot="90 90 90" size="0.25" rotstrength="999" rotspring="0.2" collide="true" limits="15"/>'
                        Spawn(xml,Transform(),false,true)
                    else
                        last_placed = last_placed - 0.1
                    end

                else
                    PlayLoop(loop, GetPlayerPos(), 0.25)
                    last_placed = last_placed - 0.1
                end
            end
        end
    else
        new_equip = true
    end
end


function menu()
	
	UiAlign("center top")
	UiButtonHoverColor(0.6, 0.6, 0.6)

	UiPush()
		UiColor(1, 1, 1)
		UiTranslate(UiCenter(), 75)
		UiFont("bold.ttf", 80)
		UiText("Welder menu", true)
	UiPop()

	UiPush()
		UiColor(1, 1, 1)
		UiTranslate(UiCenter(), UiHeight() / 2.8)
		UiFont("bold.ttf", 50)
		--UiAlign("left top")
	
		if HIDE_TEXT then
			UiColor(0.9, 0.7, 0.7)
			if UiTextButton("[    ] Show Texts", 20, 20) then
				HIDE_TEXT = false
				SetBool("savegame.mod.hide_text", false)
			end
			UiTranslate(0, 70)
			UiFont("bold.ttf", 35)
			UiText("Text Hidden", true)
		else
            UiColor(0.7, 0.9, 0.7)
			if UiTextButton("[X] Show Texts", 20, 20) then
				HIDE_TEXT = true
				SetBool("savegame.mod.hide_text", true)
			end
			UiTranslate(0, 70)
			UiFont("bold.ttf", 35)
			UiText("Text Shown", true)
		end
        
        UiTranslate(20, 20)
        UiColor(1, 1, 1)
        UiFont("bold.ttf", 50)
        UiText("Welding radius (broken)", true)
        UiFont("bold.ttf", 35)
        UiImageBox("ui/common/box-solid-6.png", 316, 16, 6, 6)
        UiColor(0.1, 0.1, 0.1)
        UiTranslate(-316/2 + 5, 0)
        WELD_RADIUS = UiSlider("ui/common/dot.png","x",WELD_RADIUS, 5, 300)
        SetInt("savegame.mod.weld_radius", WELD_RADIUS)
        if WELD_RADIUS < 90 then
            UiColor(0.7, 1, 0.7)
        elseif WELD_RADIUS < 150 then
            UiColor(1, 1, 0.7)
        else
            UiColor(1, 0.7, 0.7)
        end
            
        UiTranslate(316/2-5, 15)
        --UiText(math.floor(WELD_RADIUS/3).." cm", true)
        UiText("25 cm", true)
        if WELD_RADIUS >= 150 then
            UiColor(1, 1, 1)
            UiFont("bold.ttf", 20)
            UiText("Too large values can cause a bad experience (Things being welded together that shouldn't be)", true)    
            UiFont("bold.ttf", 35)
        end

	UiPop()

end
